'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.isNotNull = isNotNull;
exports.isNull = isNull;
exports.isBoolean = isBoolean;
exports.isTrue = isTrue;
exports.isFalse = isFalse;
exports.isNumber = isNumber;
exports.isNotANumber = isNotANumber;
exports.isInfinity = isInfinity;
exports.isString = isString;
exports.isObject = isObject;
exports.isPlainObject = isPlainObject;
exports.isArray = isArray;
exports.isRegExp = isRegExp;
exports.isDate = isDate;
exports.isFunction = isFunction;
exports.isEmail = isEmail;
exports.isUppercase = isUppercase;
exports.isLowercase = isLowercase;
exports.isNotEmpty = isNotEmpty;
exports.isEmpty = isEmpty;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashLangIsArray = require('lodash/lang/isArray');

var _lodashLangIsArray2 = _interopRequireDefault(_lodashLangIsArray);

var _lodashLangIsBoolean = require('lodash/lang/isBoolean');

var _lodashLangIsBoolean2 = _interopRequireDefault(_lodashLangIsBoolean);

var _lodashLangIsDate = require('lodash/lang/isDate');

var _lodashLangIsDate2 = _interopRequireDefault(_lodashLangIsDate);

var _lodashLangIsEmpty = require('lodash/lang/isEmpty');

var _lodashLangIsEmpty2 = _interopRequireDefault(_lodashLangIsEmpty);

var _lodashLangIsFinite = require('lodash/lang/isFinite');

var _lodashLangIsFinite2 = _interopRequireDefault(_lodashLangIsFinite);

var _lodashLangIsFunction = require('lodash/lang/isFunction');

var _lodashLangIsFunction2 = _interopRequireDefault(_lodashLangIsFunction);

var _lodashLangIsNaN = require('lodash/lang/isNaN');

var _lodashLangIsNaN2 = _interopRequireDefault(_lodashLangIsNaN);

var _lodashLangIsNull = require('lodash/lang/isNull');

var _lodashLangIsNull2 = _interopRequireDefault(_lodashLangIsNull);

var _lodashLangIsNumber = require('lodash/lang/isNumber');

var _lodashLangIsNumber2 = _interopRequireDefault(_lodashLangIsNumber);

var _lodashLangIsObject = require('lodash/lang/isObject');

var _lodashLangIsObject2 = _interopRequireDefault(_lodashLangIsObject);

var _lodashLangIsPlainObject = require('lodash/lang/isPlainObject');

var _lodashLangIsPlainObject2 = _interopRequireDefault(_lodashLangIsPlainObject);

var _lodashLangIsRegExp = require('lodash/lang/isRegExp');

var _lodashLangIsRegExp2 = _interopRequireDefault(_lodashLangIsRegExp);

var _lodashLangIsString = require('lodash/lang/isString');

var _lodashLangIsString2 = _interopRequireDefault(_lodashLangIsString);

var _lodashLangIsTypedArray = require('lodash/lang/isTypedArray');

var _lodashLangIsTypedArray2 = _interopRequireDefault(_lodashLangIsTypedArray);

var _lodashLangIsUndefined = require('lodash/lang/isUndefined');

var _lodashLangIsUndefined2 = _interopRequireDefault(_lodashLangIsUndefined);

// Type validators

function isNotNull(value) {
  return !(0, _lodashLangIsNull2['default'])(value) && !(0, _lodashLangIsUndefined2['default'])(value);
}

function isNull(value) {
  return (0, _lodashLangIsNull2['default'])(value) || (0, _lodashLangIsUndefined2['default'])(value);
}

function isBoolean(value) {
  return (0, _lodashLangIsBoolean2['default'])(value);
}

function isTrue(value) {
  return value === true;
}

function isFalse(value) {
  return value === false;
}

function isNumber(value) {
  return (0, _lodashLangIsNumber2['default'])(value) && !(0, _lodashLangIsNaN2['default'])(value) && (0, _lodashLangIsFinite2['default'])(value);
}

function isNotANumber(value) {
  return (0, _lodashLangIsNaN2['default'])(value);
}

function isInfinity(value) {
  return (0, _lodashLangIsNumber2['default'])(value) && !(0, _lodashLangIsNaN2['default'])(value) && !(0, _lodashLangIsFinite2['default'])(value);
}

function isString(value) {
  return (0, _lodashLangIsString2['default'])(value);
}

function isObject(value) {
  return (0, _lodashLangIsObject2['default'])(value);
}

function isPlainObject(value) {
  return (0, _lodashLangIsPlainObject2['default'])(value);
}

function isArray(value) {
  return (0, _lodashLangIsArray2['default'])(value) || (0, _lodashLangIsTypedArray2['default'])(value);
}

function isRegExp(value) {
  return (0, _lodashLangIsRegExp2['default'])(value);
}

function isDate(value) {
  return (0, _lodashLangIsDate2['default'])(value);
}

function isFunction(value) {
  return (0, _lodashLangIsFunction2['default'])(value);
}

// String validators

function isEmail(value) {
  return (/^.+@.+$/.test(value)
  );
}

function isUppercase(value) {
  return (0, _lodashLangIsString2['default'])(value) && value.toUpperCase() === value;
}

function isLowercase(value) {
  return (0, _lodashLangIsString2['default'])(value) && value.toLowerCase() === value;
}

// Length validators

function isNotEmpty(value) {
  return !(0, _lodashLangIsEmpty2['default'])(value);
}

function isEmpty(value) {
  return (0, _lodashLangIsEmpty2['default'])(value);
}